'=========================================================================
'   ςςԂт VB.NETTv
'-------------------------------------------------------------------------
'   [MessageBox] gbZ[W{bNXNX
'-------------------------------------------------------------------------
'   쐬  :   2003/12/25
'   :   Visual Studio.NET 2003 / Windows XP Pro SP1
'               ()炭 Windows XP삵Ȃ͂łB
'                   Windows 2000łSPɂĂ͓삷邩H(mF)
'=========================================================================
Option Strict On

Imports System.Runtime.InteropServices
Imports System.ComponentModel

Public Class MessageBoxEx

    Private Const LANG_ID As Integer = &H400

    <DllImport("User32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Function GetActiveWindow() As IntPtr
    End Function

    <DllImport("User32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Function MessageBoxTimeout( _
        ByVal hwnd As HandleRef, _
        ByVal lpText As String, _
        ByVal lpCaption As String, _
        ByVal uType As Integer, _
        ByVal wLanguageId As Integer, _
        ByVal dwTimeOut As Integer _
        ) As Integer
    End Function

    Public Enum DialogResult As Integer
        None = 0
        OK = 1
        Cancel = 2
        Abort = 3
        Retry = 4
        Ignore = 5
        Yes = 6
        No = 7
        Close = 8
        Help = 9
        TryAgain = 10
        Continue = 11
        TimeOut = 32000
    End Enum

    Private Shared Function ShowCore(ByVal owner As IWin32Window, ByVal [text] As String, _
                                     ByVal caption As String, ByVal buttons As MessageBoxButtons, _
                                     ByVal icon As MessageBoxIcon, ByVal defaultButton As MessageBoxDefaultButton, _
                                     ByVal options As MessageBoxOptions, ByVal timeout As Integer) As MessageBoxEx.DialogResult

        Dim intMsgBoxStyle As Integer
        Dim ptrOwner As IntPtr

        intMsgBoxStyle = buttons Or icon Or defaultButton Or options
        ptrOwner = IntPtr.Zero
        If (options And &H220000) = 0 Then
            If IsNothing(owner) Then
                ptrOwner = GetActiveWindow()
            Else
                ptrOwner = owner.Handle
            End If
        End If

        Return CType(MessageBoxTimeout(New HandleRef(owner, ptrOwner), [text], caption, intMsgBoxStyle, LANG_ID, timeout), MessageBoxEx.DialogResult)

    End Function

    Public Shared Function Show(ByVal [text] As String, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(Nothing, [text], "", 0, 0, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal owner As IWin32Window, ByVal [text] As String, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(owner, [text], "", 0, 0, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal [text] As String, ByVal caption As String, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(Nothing, [text], caption, 0, 0, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal owner As IWin32Window, ByVal [text] As String, ByVal caption As String, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(owner, [text], caption, 0, 0, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(Nothing, [text], caption, buttons, 0, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal owner As IWin32Window, ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(owner, [text], caption, buttons, 0, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal icon As MessageBoxIcon, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(Nothing, [text], caption, buttons, icon, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal owner As IWin32Window, ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal icon As MessageBoxIcon, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(owner, [text], caption, buttons, icon, 0, 0, timeout)
    End Function

    Public Shared Function Show(ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal icon As MessageBoxIcon, ByVal defaultButton As MessageBoxDefaultButton, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(Nothing, [text], caption, buttons, icon, defaultButton, 0, timeout)
    End Function

    Public Shared Function Show(ByVal owner As IWin32Window, ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal icon As MessageBoxIcon, ByVal defaultButton As MessageBoxDefaultButton, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(owner, [text], caption, buttons, icon, defaultButton, 0, timeout)
    End Function

    Public Shared Function Show(ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal icon As MessageBoxIcon, ByVal defaultButton As MessageBoxDefaultButton, ByVal options As MessageBoxOptions, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(Nothing, [text], caption, buttons, icon, defaultButton, options, timeout)
    End Function

    Public Shared Function Show(ByVal owner As IWin32Window, ByVal [text] As String, ByVal caption As String, ByVal buttons As MessageBoxButtons, ByVal icon As MessageBoxIcon, ByVal defaultButton As MessageBoxDefaultButton, ByVal options As MessageBoxOptions, ByVal timeout As Integer) As MessageBoxEx.DialogResult
        Return ShowCore(owner, [text], caption, buttons, icon, defaultButton, options, timeout)
    End Function

End Class
